package api

import (
	"github.com/gin-gonic/gin"
	"github.guxuan/haibei/internal/mods/common/biz"
	"github.guxuan/haibei/internal/mods/common/schema"
	"github.guxuan/haibei/pkg/util"
)

// Defining the `Area` api.
type Area struct {
	AreaBIZ *biz.Area
}

// @Tags 区域模块
// @Security ApiKeyAuth
// @Summary Query area list
// @Param current query int true "pagination index" default(1)
// @Param pageSize query int true "pagination size" default(10)
// @Success 200 {object} util.ResponseResult{data=[]schema.Area}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/areas [get]
func (a *Area) Query(c *gin.Context) {
	ctx := c.Request.Context()
	var params schema.AreaQueryParam
	if err := util.ParseQuery(c, &params); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.AreaBIZ.Query(ctx, params)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResPage(c, result.Data, result.PageResult)
}

// @Tags 区域模块
// @Security ApiKeyAuth
// @Summary Get area record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult{data=schema.Area}
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/areas/{id} [get]
func (a *Area) Get(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	item, err := a.AreaBIZ.Get(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, item)
}

// @Tags 区域模块
// @Security ApiKeyAuth
// @Summary Create area record
// @Param body body schema.AreaForm true "Request body"
// @Success 200 {object} util.ResponseResult{data=schema.Area}
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/areas [post]
func (a *Area) Create(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.AreaForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}

	result, err := a.AreaBIZ.Create(ctx, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResSuccess(c, result)
}

// @Tags 区域模块
// @Security ApiKeyAuth
// @Summary Update area record by ID
// @Param id path string true "unique id"
// @Param body body schema.AreaForm true "Request body"
// @Success 200 {object} util.ResponseResult
// @Failure 400 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/areas/{id} [put]
func (a *Area) Update(c *gin.Context) {
	ctx := c.Request.Context()
	item := new(schema.AreaForm)
	if err := util.ParseJSON(c, item); err != nil {
		util.ResError(c, err)
		return
	} else if err := item.Validate(); err != nil {
		util.ResError(c, err)
		return
	}
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.AreaBIZ.Update(ctx, id, item)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}

// @Tags 区域模块
// @Security ApiKeyAuth
// @Summary Delete area record by ID
// @Param id path string true "unique id"
// @Success 200 {object} util.ResponseResult
// @Failure 401 {object} util.ResponseResult
// @Failure 500 {object} util.ResponseResult
// @Router /api/v1/areas/{id} [delete]
func (a *Area) Delete(c *gin.Context) {
	ctx := c.Request.Context()
	id, err := util.GetQueryID(c)
	if err != nil {
		util.ResError(c, err)
		return
	}
	err = a.AreaBIZ.Delete(ctx, id)
	if err != nil {
		util.ResError(c, err)
		return
	}
	util.ResOK(c)
}
